<?php

/******************************************************************************************
 * Plugin Name: WPAutoBlog Meta Tags
 * Description: Support for WPAutoBlog to add meta-title, meta-description and keywords via Rest-API
 * Author: WPAutoBlog
 * Author URI: https://WPAutoBlog.com
 * Plugin URI: https://WPAutoBlog.com/plugin
 * Version: 1.0.0
 * License: GPLv2 or later
 *****************************************************************************************/
add_filter( 'unzip_file_use_ziparchive', '__return_false' );
add_action('plugins_loaded', 'WPAutoBlog_Meta_Tags_Function');

class WPAutoBlog_Meta_Tags {

    public function __construct() {
        add_action('rest_api_init', array($this, 'register_meta_hook'));
    }

    public function register_meta_hook() {

        register_rest_field(['post'],
            'meta',
            array(
                'schema'          => null,
                'get_callback'    => array($this, 'get_post_meta_for_wpautoblog'),
                'update_callback' => array($this, 'update_post_meta_from_wpautoblog'),
            )
        );
    }


    public function get_post_meta_for_wpautoblog($object, $field_name, $request) {
        $post_id = $object['id'];
        $meta = get_post_meta($post_id);
        return $meta;
    }


    public function update_post_meta_from_wpautoblog($value, $data, $field_name) {
        foreach ($value as $k => $v) {
            if (!empty($k)) {
              
                update_post_meta($data->ID, $k, $v);
                update_post_meta($data->ID, '_' . $k, $v);

            }
        }
    }
}

function WPAutoBlog_Meta_Tags_Function() {
    $WPAutoBlog_Meta_Tags = new WPAutoBlog_Meta_Tags();
}
